#include <stdio.h>
#include <stdlib.h>
#include "linkedstack.h"

int partition (int value[], int start, int end)
{
    int x = value[end];
    int index = (start - 1);
    int temp = 0;
 
    for (int j = start; j <= end- 1; j++)
    {
        if (value[j] <= x)
        {
            index++;
            temp = value[index];
            value[index] = value[j];
            value[j] = temp;
        }
    }
    temp = value[index+1];
    value[index+1] = value[end];
    value[end] = temp;

    return (index + 1);
}

void quickSort(int value[], int start, int end)
{
    LinkedStackNode *pNode1 = NULL;
    LinkedStackNode *pNode2 = NULL;
    LinkedStack *pStack = NULL;

    pStack = createLinkedStack();
    if (pStack == NULL)
        return;
    
    pushLS(pStack, start);
    pushLS(pStack, end);
 
    while(!isLinkedStackEmpty(pStack))
    {
        pNode1 = popLS(pStack);
        pNode2 = popLS(pStack);
        if (pNode1 == NULL && pNode2 == NULL) {
            break;
        }
        end = pNode1->data;
        start = pNode2->data;

        int p = partition( value, start, end );
        if ( p-1 > start )
        {
            pushLS(pStack, start);
            pushLS(pStack, p - 1);
        }
        if ( p+1 < end )
        {
            pushLS(pStack, p + 1);
            pushLS(pStack, end);
        }
        free( pNode1 );
        free( pNode2 );
    }
    
    deleteLinkedStack(pStack);
}
